diff --git a/src/backend/pipeline/stream.c b/src/backend/pipeline/stream.c
index d8501f87e..ef978c0b8 100644
--- a/src/backend/pipeline/stream.c
+++ b/src/backend/pipeline/stream.c
@@ -201,6 +201,9 @@ bool InsertTargetIsStream(InsertStmt *ins)
 	if (reloid != InvalidOid)
 		return false;
 
+	if (!GlobalStreamBuffer)
+		InitGlobalStreamBuffer();
+
 	return IsInputStream(ins->relation->relname);
 }
 
diff --git a/src/backend/tcop/postgres.c b/src/backend/tcop/postgres.c
index b7d05be36..b34d7dca5 100644
--- a/src/backend/tcop/postgres.c
+++ b/src/backend/tcop/postgres.c
@@ -4560,6 +4560,9 @@ PostgresMain(int argc, char *argv[],
 					encoding = pq_getmsgstring(&input_message);
 					channel = pq_getmsgstring(&input_message);
 
+					if (!GlobalStreamBuffer)
+						InitGlobalStreamBuffer();
+
 					exec_proxy_events(encoding, channel, &input_message);
 					send_ready_for_query = true;
 				}
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 5a2158679..28243ad58 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -942,8 +942,6 @@ InitPostgres(const char *in_dbname, Oid dboid, const char *username,
 	if (!bootstrap)
 		pgstat_bestart();
 
-	InitGlobalStreamBuffer();
-
 	/* close the transaction we started above */
 	if (!bootstrap)
 		CommitTransactionCommand();
